## intel-graphics-compiler2 2.16.0

=== IGC/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2017-2024 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================


# CMake settings:
#  - IGC_OPTION__LIBRARY_NAME
# FCL
#  - FCL_OPTION__LIBRARY_NAME
#  - IGC_OPTION__ARCHITECTURE_HOST
#  - IGC_OPTION__ARCHITECTURE_TARGET
#  - IGC_OPTION__BIF_LINK_BC
#  - IGC_OPTION__INCLUDE_IGC_COMPILER_TOOLS
#  - IGC_OPTION__OUTPUT_DIR

cmake_minimum_required(VERSION 3.13.4 FATAL_ERROR)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Default languages: C, C++.
project(IGC)

if(UNIX)
  include(GNUInstallDirs)
endif()



# Increment IGC_API_MAJOR_VERSION if there is ABI Change.
if(NOT DEFINED IGC_API_MAJOR_VERSION)
  set(IGC_API_MAJOR_VERSION 2)
endif()
if(NOT DEFINED IGC_API_MINOR_VERSION)
  set(IGC_API_MINOR_VERSION 16)
endif()
if(NOT DEFINED IGC_API_PATCH_VERSION)
  set(IGC_API_PATCH_VERSION 0)
endif()

# IGC_BUILD_METADATA
# Used as version suffix, to distinguish builds with the same semantic version
# Eg. libigc-1.2.3+x and libigc-1.2.3+y
if(NOT DEFINED IGC_BUILD_METADATA)
  if(DEFINED ENV{IGC_BUILD_METADATA})
    set(IGC_BUILD_METADATA $ENV{IGC_BUILD_METADATA})
  else()
    set(IGC_BUILD_METADATA 0)
  endif()
endif()

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

# ======================================================================================================
# ================================================ UTILS ===============================================
# ======================================================================================================


list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/BiFModule/cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

include(igc_flags_utils)
include(igc_arch_utils)
include(igc_resource_utils)
include(igc_source_group_utils)
include(igc_llvm_utils)
include(igc_imported_tools)

# ======================================================================================================
# ======================================================================================================
# ======================================================================================================


# ======================================================================================================
# ==================================== BUILD CONFIGURATIONS (part 1) ===================================
# ======================================================================================================

# IGC project available configuration types:
set(IGC_CMAKE_CONFIGURATION_TYPES
  "Debug"
  "Release"
)
set(IGC_CMAKE_CONFIGURATION_TYPES ${IGC_CMAKE_CONFIGURATION_TYPES} CACHE STRING "IGC available build configurations." FORCE)

if(CMAKE_CONFIGURATION_TYPES)
  # Multi-configuration generator: use CMAKE_CONFIGURATION_TYPES variable
  set(CMAKE_CONFIGURATION_TYPES ${IGC_CMAKE_CONFIGURATION_TYPES})

  if(CMAKE_BUILD_TYPE)
    message(FATAL_ERROR "CMAKE_BUILD_TYPE variable is not allowed while using multi-configuration generator!")
  endif()
else()
  # Single-configuration generator: use CMAKE_BUILD_TYPE variable
  if(DEFINED CMAKE_BUILD_TYPE)
    string(TOLOWER "${CMAKE_BUILD_TYPE}" _buildType)
    string(STRIP "${_buildType}" _buildType)

    if(_buildType MATCHES "^release$")
      set(_buildType "Release")
    elseif(_buildType MATCHES "^debug$")
      set(_buildType "Debug")
    else()
      set(_buildType "Release")
      message(WARNING "CMAKE_BUILD_TYPE: Unknown build configuration. The following configurations are available: ${IGC_CMAKE_CONFIGURATION_TYPES}.\nThe \"${_buildType}\" configuration will be used.\nThis value has meaning only for single-configuration generators (like Make). It will be ignored for MSVC/XCode.")
    endif()
  else()
    set(_buildType "Release")
    message(WARNING "CMAKE_BUILD_TYPE: No build configuration specified. The following configurations are available: ${IGC_CMAKE_CONFIGURATION_TYPES}.\nThe \"${_buildType}\" configuration will be used.\nThis value has meaning only for single-configuration generators (like Make). It will be ignored for MSVC/XCode.")
  endif()
  set(CMAKE_BUILD_TYPE "${_buildType}")
  unset(_buildType)
endif()

# Patterns which identify debug and release configurations.
set(IGC_BUILD__DEBUG_PATTERN   "^Debug$")
set(IGC_BUILD__RELEASE_PATTERN "^Release$")

# The configuration variables used below are likely to have been most recently
# defined by the project statement's call to the toolchain file
# ${CMAKE_TOOLCHAIN_FILE}.

# Some known cmake variables describing compiler:
# - CMAKE_CXX_COMPILER_ID == "Clang..." -> Clang
# - CMAKE_CXX_COMPILER_ID == "GNU"   -> GCC
# - CMAKE_CXX_COMPILER_ID == "Intel" -> Intel C++
# - CMAKE_CXX_COMPILER_ID == "MSVC"  -> using Visual Studio C++

# Local variables describing compilers:
# _igc_compiler_is_gnu       - C/C++ is gcc/g++ (not clang)
# _igc_compiler_is_clang     - C/C++ is clang/clang++ (not gcc/g++)
# _igc_compiler_is_gnu_or_clang  = C/C++ is either gnu or clang

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(_igc_compiler_is_gnu 1)
else()
  set(_igc_compiler_is_gnu 0)
endif()

if((CMAKE_C_COMPILER_ID MATCHES "Clang") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
  set(_igc_compiler_is_clang 1)
else()
  set(_igc_compiler_is_clang 0)
endif((CMAKE_C_COMPILER_ID MATCHES "Clang") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))

if(_igc_compiler_is_gnu OR _igc_compiler_is_clang)
  set(_igc_compiler_is_gnu_or_clang 1)
else()
  set(_igc_compiler_is_gnu_or_clang 0)
endif(_igc_compiler_is_gnu OR _igc_compiler_is_clang)

#
#  First, Set IGC_OPTION__ARCHITECTURE_TARGET, IGC_OPTION__ARCHITECTURE_HOST,
#  and IGC_BUILD__CROSSCOMPILE_NEEDED.
#
igc_arch_detect(IGC_BUILD__DETECTED_ARCHITECTURE_TARGET IGC_BUILD__DETECTED_ARCHITECTURE_HOST)
igc_arch_validate(_detectedTargetArchValid "${IGC_BUILD__DETECTED_ARCHITECTURE_TARGET}")
igc_arch_validate(_detectedHostArchValid   "${IGC_BUILD__DETECTED_ARCHITECTURE_HOST}")

if(DEFINED IGC_OPTION__ARCHITECTURE_TARGET)
  igc_arch_normalize(_targetArchitecture "${IGC_OPTION__ARCHITECTURE_TARGET}")
elseif(_detectedTargetArchValid)
  set(_targetArchitecture "${IGC_BUILD__DETECTED_ARCHITECTURE_TARGET}")
  message(WARNING "IGC_OPTION__ARCHITECTURE_TARGET: Target architecture is not specified. Trying to deduce it from context.")
else()
  message(FATAL_ERROR "IGC_OPTION__ARCHITECTURE_TARGET: Target architecture is not specified and cannot be deduced from context.\nPlease specify one, e.g. Windows32, Linux64, Android32, ...")
endif()

if(DEFINED IGC_OPTION__ARCHITECTURE_HOST)
  igc_arch_normalize(_hostArchitecture "${IGC_OPTION__ARCHITECTURE_HOST}")
elseif(_detectedHostArchValid)
  set(_hostArchitecture "${IGC_BUILD__DETECTED_ARCHITECTURE_HOST}")
  if(CMAKE_CROSSCOMPILING)
    message(WARNING "IGC_OPTION__ARCHITECTURE_HOST: Host architecture is not specified. Trying to deduce it from context.")
  endif()
elseif(CMAKE_CROSSCOMPILING)
  message(FATAL_ERROR "IGC_OPTION__ARCHITECTURE_HOST: Host architecture is not specified and cannot be deduced from context.\nPlease specify one, e.g. Windows32, Linux64, Android32, ...")
else()
  set(_hostArchitecture "${_targetArchitecture}")
endif()

igc_arch_crosscompile_needed(IGC_BUILD__CROSSCOMPILE_NEEDED "${_targetArchitecture}" "${_hostArchitecture}")

set(IGC_OPTION__ARCHITECTURE_TARGET "${_targetArchitecture}" CACHE STRING "Target architecture for compilation." FORCE)
set(IGC_OPTION__ARCHITECTURE_HOST   "${_hostArchitecture}"   CACHE STRING "Architecture of host used during compilation. Only used when cross-compiling." FORCE)
unset(_detectedTargetArchValid)
unset(_detectedHostArchValid)
unset(_targetArchitecture)
unset(_hostArchitecture)


# GFX_DEVELOPMENT_DIR shall be provided by UFO build system
if(NOT GFX_DEVELOPMENT_DIR)
  get_filename_component(GFX_DEVELOPMENT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../ ABSOLUTE)
endif()

find_program(PYTHON_EXECUTABLE NAMES "python3" "python")

set(IGC_CODEGEN_BASE_DIR "${CMAKE_CURRENT_BINARY_DIR}/autogen")
if(MSVC_IDE)
    set(IGC_CODEGEN_DIR "${IGC_CODEGEN_BASE_DIR}/${IGC_CMAKE_CFG_INTDIR}")
elseif(MSVC)
    set(IGC_CODEGEN_DIR "${IGC_CODEGEN_BASE_DIR}/${IGC_CMAKE_CFG_INTDIR}")
else()
    set(IGC_CODEGEN_DIR "${IGC_CODEGEN_BASE_DIR}")
endif()
add_subdirectory(MDAutogen ${IGC_CODEGEN_BASE_DIR}/MDAutogen)
set_source_files_properties(${IGC_CODEGEN_DIR}/MDNodeFunctions.gen PROPERTIES GENERATED TRUE)


# ============================================================================
# ========== BUILD CONFIGURATIONS (part 2) ===================================
# ============================================================================
# The section must be after project definition and its supported languages because otherwise
# used variables are not available yet.

# Generate debug symbols even in release mode, thus making it possible to produce
# separate Debian/RPM debug information packages.
# FIXME: Instead of hacking the release build flags, consider using CMake's
# RelWithDebInfo build type.
if(UNIX)
  set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -g")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -g")
  set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} -g")
  set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -g")
endif()


# Populating global property with list of debug configurations (based on pattern).
set(_debugConfigs)
foreach(_configName ${CMAKE_CONFIGURATION_TYPES} ${CMAKE_BUILD_TYPE})
  if(_configName MATCHES "${IGC_BUILD__DEBUG_PATTERN}")
    list(APPEND _debugConfigs "${_configName}")
  endif()
endforeach()
set_property(GLOBAL PROPERTY DEBUG_CONFIGURATIONS ${_debugConfigs})
unset(_debugConfigs)

# ======================================================================================================
# ======================================================================================================
# ======================================================================================================


# ======================================================================================================
# ========================================= BUILD CMAKE OPTIONS ========================================
# ======================================================================================================

include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/igc_library_name.cmake")
set(IGC_LIBRARY_NAME ${IGC_LIBRARY_NAME} PARENT_SCOPE)

set(FCL_ENABLED ON)


if (FCL_ENABLED)
  #FCL
  if(DEFINED FCL_OPTION__LIBRARY_NAME)
    set(FCL_LIBRARY_NAME "${FCL_OPTION__LIBRARY_NAME}")
  else()
    set(FCL_LIBRARY_NAME "igdfcl")
  endif()
  set(FCL_LIBRARY_NAME ${FCL_LIBRARY_NAME} PARENT_SCOPE)

  set(_allowBifLink ON)
  set(IGC_OPTION__BIF_LINK_BC ${_allowBifLink} CACHE BOOL "Built-in Functions: Link .bc files into final shared libraries.")
  mark_as_advanced(IGC_OPTION__BIF_LINK_BC)
  unset(_allowBifLink)
endif()

# TODO: Remove this flag once only LLVM 16+ is supported (no possibility to enable typed pointers).
if(IGC_OPTION__LLVM_PREFERRED_VERSION VERSION_GREATER_EQUAL 16)
  option(IGC_OPTION__API_ENABLE_OPAQUE_POINTERS "[Experimental] Enable opaque pointers across the IGC stack.\
    Forces opaque pointers' usage in IGC/LLVM passes, OCL Clang FE and built-in functions' bitcode.\
    Enabled by default for LLVM 16+." ON)
else()
  option(IGC_OPTION__API_ENABLE_OPAQUE_POINTERS "[Experimental] Enable opaque pointers across the IGC stack.\
    Forces opaque pointers' usage in IGC/LLVM passes, OCL Clang FE and built-in functions' bitcode.\
    Enabled by default for LLVM 16+." OFF)
endif()

option(IGC_OPTION__ENABLE_LIT_TESTS "Enable lit testing for IGC compiler. May require additional tools like llvm lit and opt" OFF)

=== visa/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2017-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================


# This file sets up the following libraries and executables:
# Target name                |     CMake project name             |   Supported Platforms
#----------------------------+------------------------------------+---------------------------
# GenX_IR.exe (GenX_IR)      |     GenX_IR_Exe                    |   Windows, Linux
# vISA libs will be linked directly into igc.dll

include(Functions.cmake)

# TODO: Move this to a common file?
# Get the latest commit hash
execute_process(
    COMMAND git rev-parse HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE)

add_definitions(-DGIT_COMMIT_HASH=\"${GIT_COMMIT_HASH}\")

#none of the values about 32/64 are being propogated down
#and BuildSetup.cmake is not part of IGC enviroment
#so setting it manually

# Distinguish between 32 and 64 bits
# The string that is set is used to modify the target names of some of the libraries generated
if(CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(TARGET_MODIFIER "32")
    set(PB_PATH_MODIFIER "x86")
elseif(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(TARGET_MODIFIER "64")
    set(PB_PATH_MODIFIER "x64")
else()
    message(FATAL_ERROR "unexpected platform")
endif()

set(LINK_DLL_IGA 1)


# Set up build flags to use dynamic multi-threaded runtime (/MD) or
# to use static multi-threaded runtime (/MT)
option(LINK_AS_STATIC_LIB "link with /MT or /MD" ON)


################################################################################
# FC_link Related

if (WIN32)
message("-- Configuring Fast Composite Component")
add_subdirectory(FC_linker)
endif (WIN32)
################################################################################
# IGA Related
#
#   Controls whether internal or external GED is used and whether IP sensitive
#   code is used or not (with appropriate changes in IGA).
#

  set(GED_BRANCH GED_external)

message("-- Configuring Intel Gen Assembler (IGA) Component")
message("--  - GED_BRANCH:           ${GED_BRANCH}")
message("--  - CMAKE_CXX_COMPILER:   ${CMAKE_CXX_COMPILER}")
add_subdirectory(iga/GEDLibrary/${GED_BRANCH})
add_subdirectory(iga/IGALibrary)
if (WIN32 OR UNIX)
  add_subdirectory(iga/IGAExe)
endif (WIN32 OR UNIX)

if(WIN32)
  cmake_minimum_required(VERSION 3.1)
  cmake_policy(SET CMP0043 OLD)
else()
  cmake_minimum_required(VERSION 2.8.12)
endif(WIN32)

# In the case where this is the IGC build we need to add a dummy custom target check_headers
add_custom_target(check_headers)

set_target_properties(check_headers PROPERTIES FOLDER "Misc")

if(MSVC)
  bs_set_wdk(check_headers)
endif(MSVC)

if(BS_USE_OSDM_BUILD_SYSTEM)
  include(${BUILD_SYS_INC}/utils.cmake)
  # Locate bison and flex using common bs macro
  bs_find_flex()
  bs_find_bison()
  if (WIN32)
    set(WIN_FLEX_FLAG "--wincompat")
  endif(WIN32)
else()
  # Locate bison and flex if we're on windows (they're included in the repository)
  # The following commands will prime the CMake cache with the local paths to the relevant executables and
  # prevent the find_package commands from looking elsewhere
  if (WIN32)
    # Find the GNUTools path
    # In CM_RT depo, GNUTools is in the same level with CM_jitter
    # In gfx_Development depo, GNUTools is in media/cmrtlib/proprietary
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../GNUTools)
      set(GNUTOOLS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../GNUTools)
    elseif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../../../media/cmrtlib/GNUTools)
      set(GNUTOOLS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../../media/cmrtlib/GNUTools)
    elseif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../cmc/support/GNUTools)
      set(GNUTOOLS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../cmc/support/GNUTools)
    else ()
      message( FATAL_ERROR "No GNUTools folder found.")
    endif ()
    find_program(BISON_EXECUTABLE bison.bat PATHS ${GNUTOOLS_DIR}/bin DOC "path to the bison executable")
    find_program(FLEX_EXECUTABLE flex PATHS ${GNUTOOLS_DIR}/bin DOC "path to the flex executable")
    #set (BISON_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/../GNUTools/bin/bison)
    #set (FLEX_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/../GNUTools/bin/flex)
    set (ENV{M4} "${GNUTOOLS_DIR}/bin/m4.exe")
  endif (WIN32)

  # Here the default package support for bison and flex is invoked. This does something for Windows
  # and Linux but is effectively by-passed for Android as we've already explicitly set the bison and
  # flex executable variables for that platform
  find_package(BISON)
  find_package(FLEX)
endif()
# Set up the bison and flex targets. These commands will set up commands to generate the appropriate
# source files from the input grammars. It will also set up the dependencies correctly for any
# library or executable that uses the generated source

set(bison_output_file ${CMAKE_CURRENT_BINARY_DIR}/CISA.tab.cpp)
set(flex_output_file ${CMAKE_CURRENT_BINARY_DIR}/lex.CISA.cpp)

BISON_TARGET(CISAParser CISA.y ${bison_output_file} COMPILE_FLAGS "-vt -p CISA")
FLEX_TARGET(CISAScanner CISA.l ${flex_output_file} COMPILE_FLAGS "-PCISA ${WIN_FLEX_FLAG}")
ADD_FLEX_BISON_DEPENDENCY(CISAScanner CISAParser)
set(CISAScanner_dependencies)

list(APPEND CISAScanner_dependencies
    ${FLEX_CISAScanner_OUTPUTS}
    ${BISON_CISAParser_OUTPUTS})

add_custom_target(CISAScanner_target DEPENDS ${CISAScanner_dependencies})

set_target_properties(CISAScanner_target PROPERTIES FOLDER "Misc")

if (MSVC)
  #set up standard defines from the common WDK path.
  bs_set_wdk(CISAScanner_target)
endif()

# Set up include paths used by all the libraries in this file.
set(Jitter_inc_dirs ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/include)

if (LINK_AS_STATIC_LIB)
  win_static_runtime()
else (LINK_AS_STATIC_LIB)
  win_dynamic_runtime()
endif (LINK_AS_STATIC_LIB)

include_directories(${Jitter_inc_dirs})

# Tell cmake to generate code to compile the flex and bison generated source as c++ rather than c
# (due to the fact that they are .c files rather than .cpp)
set_source_files_properties( CISA.tab.cpp lex.CISA.cpp PROPERTIES LANGUAGE CXX )

  set(LocalScheduler_SOURCES
    LocalScheduler/Dependencies_G4IR.cpp
    LocalScheduler/G4_Sched.cpp
    LocalScheduler/LatencyTable.cpp
    LocalScheduler/LocalScheduler_G4IR.cpp
    LocalScheduler/SWSB_G4IR.cpp
    )

  set(LocalScheduler_HEADERS
    LocalScheduler/Dependencies_G4IR.h
    LocalScheduler/LatencyTable.h
    LocalScheduler/LocalScheduler_G4IR.h
    LocalScheduler/SWSB_G4IR.h
    )

# Set up some common source files used in all the projects so they only need to be defined once
set(GenX_Common_Sources_VisaToG4
  VisaToG4/TranslateALU.cpp
  VisaToG4/TranslateBranches.cpp
  VisaToG4/TranslateMath.cpp
  VisaToG4/TranslateMisc.cpp
  VisaToG4/TranslateSend3D.cpp
  VisaToG4/TranslateSendLdStLegacy.cpp
  VisaToG4/TranslateSendLdStLsc.cpp
  VisaToG4/TranslateSendMedia.cpp
  VisaToG4/TranslateSendRaw.cpp
  VisaToG4/TranslateSendSync.cpp
  )

set(GenX_Common_Sources_G4_IRBuilder
  BuildIRImpl.cpp)

set(GenX_Common_Sources_G4_Passes
  Passes/AccSubstitution.cpp
  Passes/AccSubstitution.hpp
  Passes/SRSubstitution.cpp
  Passes/SRSubstitution.hpp
  Passes/InstCombine.cpp
  Passes/InstCombine.hpp
  Passes/LVN.cpp
  Passes/LVN.hpp
  Passes/MergeScalars.cpp
  Passes/MergeScalars.hpp
  Passes/SendFusion.cpp
  Passes/SendFusion.hpp
  Passes/StaticProfiling.cpp
  Passes/StaticProfiling.hpp
  )


set(GenX_Common_Sources_External_Other
  Assertions.cpp
  Attributes.cpp
  BinaryEncoding.cpp
  BinaryEncodingCNL.cpp
  BinaryEncodingIGA.cpp
  BuildCISAIRImpl.cpp
  ByteCodeReaderNG.cpp
  CFGStructurizer.cpp
  Common_BinaryEncoding.cpp
  DebugInfo.cpp
  RADebug.cpp
  FlagSpillCleanup.cpp
  FlowGraph.cpp
  FrequencyInfo.cpp
  G4_BB.cpp
  G4_IR.cpp
  G4_Kernel.cpp
  G4_SendDescs.cpp
  G4_Verifier.cpp
  GraphColor.cpp
  HWConformity.cpp
  IncrementalRA.cpp
  EmuInt64Add.cpp
  InstSplit.cpp
  JitterDataStruct.cpp
  KernelCost.cpp
  LinearScanRA.cpp
  LocalDataflow.cpp
  LocalRA.cpp
  LoopAnalysis.cpp
  Lowered_IR.cpp
  MetadataDumpRA.cpp
  Optimizer.cpp
  PhyRegUsage.cpp
  PointsToAnalysis.cpp
  PreDefinedVars.cpp
  PrologEpilog.cpp
  RPE.cpp
  ReduceExecSize.cpp
  RegAlloc.cpp
  RelocationEntry.cpp
  Rematerialization.cpp
  SCCAnalysis.cpp
  SplitAlignedScalars.cpp
  SpillCleanup.cpp
  SpillCode.cpp
  SpillManagerGMRF.cpp
  SWWA.cpp
  TranslationInterface.cpp
  VISAKernelImpl.cpp
  VarSplit.cpp
  ifcvt.cpp
  main.cpp
  ${LocalScheduler_SOURCES}
)

set(GenX_Common_Sources_External
  ${GenX_Common_Sources_External_Other}
  ${GenX_Common_Sources_G4_IRBuilder}
  ${GenX_Common_Sources_G4_Passes}
  ${GenX_Common_Sources_VisaToG4}
)

set(GenX_Common_Sources
    ${GenX_Common_Sources_External}
)

set(GenX_CISA_dis_Common_Sources
  Common_ISA_framework.cpp
  Common_ISA_util.cpp
  IsaDescription.cpp
  IsaDisassembly.cpp
  IsaVerification.cpp
  DebugInfo.cpp
)

set(Jitter_Common_Sources
  Common_ISA.cpp
)

set(Jitter_Utility_Files
  Arena.cpp
  Arena.h
  common.cpp
  Mem_Manager.cpp
  Mem_Manager.h
  Option.cpp
  )

set(GenX_Utility_Files
  BitSet.cpp
  BitSet.h
  FastSparseBitVector.h
  Timer.cpp
  Timer.h
  )

set(GenX_Common_Headers
  Attributes.hpp
  Assertions.h
  BinaryEncoding.h
  BinaryEncodingCNL.h
  BinaryEncodingIGA.h
  BuildCISAIR.h
  BuildIR.h
  CFGStructurizer.h
  Common_BinaryEncoding.h
  Common_GEN.h
  DebugInfo.h
  RADebug.h
  FlagSpillCleanup.h
  FlowGraph.h
  FrequencyInfo.h
  G4_BB.hpp
  G4_Declare.h
  G4_IR.hpp
  G4_Instruction.h
  G4_Kernel.hpp
  G4_MsgOpDefs.hpp
  G4_Opcode.h
  G4_Operand.h
  G4_Register.h
  G4_SendDescs.hpp
  G4_Verifier.hpp
  GraphColor.h
  HWConformity.h
  EmuInt64Add.h
  IGfxHwEuIsaCNL.h
  InstSplit.h
  KernelCost.hpp
  LinearScanRA.h
  LocalDataflow.h
  LocalRA.h
  Metadata.h
  MetadataDumpRA.h
  Optimizer.h
  PhyRegUsage.h
  PointsToAnalysis.h
  PreDefinedVars.h
  RPE.h
  RegAlloc.h
  RelocationEntry.hpp
  Rematerialization.h
  SCCAnalysis.h
  SpillCleanup.h
  SpillCode.h
  SpillManagerGMRF.h
  SplitAlignedScalars.h
  VISAKernel.h
  VarSplit.h
  HWCaps.inc
  include/JitterDataStruct.h
  include/KernelInfo.h
  include/KernelCostInfo.h
  include/RT_Jitter_Interface.h
  include/VISABuilderAPIDefinition.h
  include/VISAOptions.h
  include/VISADefines.h
  include/VISAOptionsDefs.h
  include/gtpin_IGC_interface.h
  include/visa_igc_common_header.h
  ${LocalScheduler_HEADERS}
)
set(GenX_CISA_dis_Common_Headers
  common.h
  Common_ISA_framework.h
  Common_ISA_util.h
  IsaDescription.h
  IsaDisassembly.h
  IsaVerification.h
  Option.h
  PlatformInfo.h
)

set(Jitter_Common_Headers
  Common_ISA.h
)

add_compile_definitions(
    $<$<CONFIG:Debug>:_DEBUG>
    $<$<CONFIG:Release>:NDEBUG>
)

# ###############################################################
# GenX_IR_Exe
# ###############################################################
if (UNIX OR WIN32)
  set(GenX_IR_EXE_SOURCES
    ${GenX_Common_Sources}
    ${GenX_CISA_dis_Common_Sources}
    ${Jitter_Common_Sources}
    )

  set(GenX_IR_EXE_UTILITY
    ${Jitter_Utility_Files}
    ${GenX_Utility_Files}
    )

  set(GenX_IR_EXE_HEADERS
    ${GenX_Common_Headers}
    ${GenX_CISA_dis_Common_Headers}
    ${Jitter_Common_Headers}
    ${GenX_Common_Headers}
    )

  set(GenX_IR_EXE_lex_yacc
    CISA.l
    CISA.y
    )

  set(GenX_IR_EXE_All_Sources
    ${GenX_IR_EXE_SOURCES}
    ${GenX_IR_EXE_UTILITY}
    ${GenX_IR_EXE_HEADERS}
    ${BISON_CISAParser_OUTPUTS}
    ${FLEX_CISAScanner_OUTPUTS}
    ${GenX_IR_EXE_lex_yacc}
    )

  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${IGC_BUILD__TOOLS_OUTPUT_DIR})
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${IGC_BUILD__TOOLS_OUTPUT_DIR})
  setup_executable(GenX_IR_Exe "${GenX_IR_EXE_All_Sources}" FALSE "GenX_IR")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "")

=== IGC/DriverInterface/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2017-2025 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================

include_directories(
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${IGC_BUILD__IGC_SRC_DIR}")

set(IGC_BUILD__SRC__DriverInterface
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/AddImplicitArgs.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/customApi.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/dllInterfaceCompute.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/FreezeIntDiv.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/ImplicitArgs.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/ProcessFuncAttributes.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/TypesLegalizationPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/LegalizeFunctionSignatures.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/ForceFunctionsToNop.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/DivergentBarrierPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/FastMathConstantHandling.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/LoadBuffer.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/Platform/cmd_media_caps_g8.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/sp/spp_g8.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/util/BinaryStream.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/UnifyIROCL.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/MoveStaticAllocas.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/MergeAllocasOCL.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/sp/zebin_builder.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/LowerInvokeSIMD.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ResolveConstExprCalls.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/preprocess_spvir/HandleSPIRVDecorations/HandleSpirvDecorationMetadata.cpp"
  )

list(APPEND IGC_BUILD__SRC__DriverInterface
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/preprocess_spvir/PreprocessSPVIR.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/preprocess_spvir/ConvertUserSemanticDecoratorOnFunctions.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/preprocess_spvir/PromoteBools.cpp"
  )

  set(IGC_BUILD__SRC__RAYTRACING
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/MemRegionAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RayTracingAddressSpaceAliasAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RayTracingIntrinsicAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RayTracingIntrinsicResolution.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RTArgs.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RTBuilder.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RTStackFormat.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RayTracingInterface.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/TraceRayInlineLoweringPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/NewTraceRayInlineLoweringPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/DynamicRayManagementPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/SplitAsyncUtils.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/CrossingAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/TraceRayInlinePrepPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/TraceRayInlineLatencySchedulerPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/OverrideTMaxPass.cpp"
    )
  list(APPEND IGC_BUILD__SRC__DriverInterface ${IGC_BUILD__SRC__RAYTRACING})


set(IGC_BUILD__HDR__DriverInterface
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/customApi.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/DivergentBarrierPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/FastMathConstantHandling.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/KernelAnnotations.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/CommandStream/SamplerTypes.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/CommandStream/SurfaceTypes.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/Platform/cmd_media_caps_g8.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/Platform/cmd_shared_def_g8.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/sp/sp_types.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/sp/spp_g8.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/util/BinaryStream.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/sp/zebin_builder.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/MoveStaticAllocas.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/MergeAllocasOCL.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/LowerInvokeSIMD.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ResolveConstExprCalls.h"

    "${IGC_BUILD__COMMON_COMPILER_DIR}/API/ErrorCode.h"
    "${IGC_BUILD__COMMON_COMPILER_DIR}/API/SurfaceFormats.h"
    "${IGC_BUILD__COMMON_COMPILER_DIR}/API/usc.h"
    "${IGC_BUILD__COMMON_COMPILER_DIR}/API/usc_config.h"
    "${IGC_BUILD__COMMON_COMPILER_DIR}/API/usc_debugControl.h"
    "${IGC_BUILD__COMMON_COMPILER_DIR}/API/usc_gen7.h"
    "${IGC_BUILD__COMMON_COMPILER_DIR}/API/usc_gen8.h"
    "${IGC_BUILD__COMMON_COMPILER_DIR}/API/usc_gen9.h"
  )

  set(IGC_BUILD__HDR__RAYTRACING
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/ConstantsEnums.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/HitGroups.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/MemRegionAnalysis.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RayTracingAddressSpaceAliasAnalysis.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RayTracingMemoryStyle.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RayTracingPasses.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RTArgs.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RTBuilder.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RTStackFormat.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/RayTracingInterface.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/CrossingAnalysis.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/SplitAsyncUtils.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/NewTraceRayInlineLoweringPass.h"
    )

  set(IGC_BUILD__HDR__RAYTRACING__API
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/API/API.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/API/BVHInfo.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/API/MemoryStyleEnum.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/API/RayDispatchGlobalData.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/API/AtomicPullSWTileWalkInterface.h"
    )
  set(IGC_BUILD__HDR__RAYTRACING_API__ADT
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/API/ADT/Array.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/RayTracing/API/ADT/Optional.h"
    )

  set(IGC_BUILD__HDR_LivenessUtils
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/LivenessUtils/MergeAllocas.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/LivenessUtils/AllocationLivenessAnalyzer.cpp"
  )
  list(APPEND IGC_BUILD__HDR__DriverInterface "${IGC_BUILD__HDR_LivenessUtils}")
  set(IGC_BUILD__SRC_LivenessUtils
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/LivenessUtils/MergeAllocas.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorCommon/LivenessUtils/AllocationLivenessAnalyzer.h"
  )
  list(APPEND IGC_BUILD__SRC__DriverInterface "${IGC_BUILD__SRC_LivenessUtils}")

list(APPEND IGC_BUILD__SRC__DriverInterface
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/igc_features_and_workarounds_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/igc_ocl_device_ctx_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/igc_ocl_translation_ctx_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/ocl_gen_binary_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/ocl_translation_output_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/gt_system_info_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/platform_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/igc_builtins_impl.cpp"
  ${CIF_SOURCES_EXPORT_ABSOLUTE_PATH}
  )


if (DX_ONLY OR VK_ONLY)
    set(IGC_BUILD__SRC__RAYTRACING_DX
        ${IGC_BUILD__SRC__RAYTRACING}
        PARENT_SCOPE
    )
    set(IGC_BUILD__HDR__RAYTRACING_DX
        ${IGC_BUILD__HDR__RAYTRACING}
        PARENT_SCOPE
    )
endif()

# Resources.
if(MSVC AND NOT (DX_ONLY OR VK_ONLY))
    igc_rc_register_resource(
        DriverInterface__igc_dll
        FILE                "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL/Resource/BuiltinResource.rc"
        INCLUDE_DIRECTORIES "${IGC_BUILD__BIF_DIR}"
                            "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/OCL"
      )
endif()


set(IGC_BUILD__SRC__IGC_DriverInterface__igc_dll
    ${IGC_BUILD__SRC__DriverInterface}
    ${IGC_BUILD__SRC_OGL__DriverInterface}
    PARENT_SCOPE
  )

set(IGC_BUILD__HDR__IGC_DriverInterface__igc_dll
    ${IGC_BUILD__HDR__DriverInterface}
    ${IGC_BUILD__HDR_OGL__DriverInterface}
    PARENT_SCOPE
  )
  igc_sg_register(
    IGC__RayTracing
    "DriverInterface\\RayTracing"
    FILES
      ${IGC_BUILD__SRC__RAYTRACING}
      ${IGC_BUILD__HDR__RAYTRACING}
  )
  igc_sg_register(
    IGC__RayTracing__API
    "DriverInterface\\RayTracing\\API"
    FILES
      ${IGC_BUILD__HDR__RAYTRACING__API}
  )
  igc_sg_register(
    IGC__RayTracing__API__ADT
    "DriverInterface\\RayTracing\\API\\ADT"
    FILES
      ${IGC_BUILD__HDR__RAYTRACING_API__ADT}
  )

igc_regex_escape(_reSrcDir "${CMAKE_CURRENT_SOURCE_DIR}")
igc_regex_escape(_reUscDir "${IGC_BUILD__COMMON_COMPILER_DIR}")

=== IGC/OCLFE/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2017-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================

#---define Dir macros---
if (MSVC)
  set(HEADER_DIR windows)
else()
  set(HEADER_DIR linux)
endif()

set(REL_GFX_DEV_PATH ${IGC_SOURCE_DIR}/../)

set(COMMON_OCL_FILES ${REL_GFX_DEV_PATH}/OpenCL/Common/)
set(CLELF_SOURCE ${COMMON_OCL_FILES}/CLElfLib/)
set(COMMON_INC_FILES ${REL_GFX_DEV_PATH}/inc/common/)
set(SOURCE_INC_FILES ${REL_GFX_DEV_PATH}/inc/)
set(SOURCE_INSTALL_FILES ${REL_GFX_DEV_PATH}/install/)

set(PLATFORM_HEADERS ${REL_GFX_DEV_PATH}/Source/OpenCL/Runtime/${HEADER_DIR}/headers/)

#---End #define Dir macros---

#----Set Source and Header Files----
set(IGC_BUILD__SRC__FCL
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/source/clang_dll.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/source/clang_tb.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/source/clang_debug.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/source/LoadBuffer.cpp"
  "${IGC_BUILD__SRC__IGC_Common_CLElfLib}"
)

set(IGC_BUILD__HDR__FCL
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/headers/clang_tb.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/headers/clang_debug.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/headers/resource.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/headers/LoadBuffer.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/TranslationBlock.h"
  "${IGC_BUILD__HDR__IGC_Common_CLElfLib}"
)

list(APPEND IGC_BUILD__SRC__FCL ${CIF_SOURCES_EXPORT_ABSOLUTE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/fcl_ocl_translation_ctx_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/fcl_ocl_device_ctx_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/ocl_translation_output_impl.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/platform_impl.cpp"
  )
list(APPEND IGC_BUILD__HDR__FCL ${CIF_HEADERS_ABSOLUTE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/fcl_ocl_translation_ctx_impl.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/fcl_ocl_device_ctx_impl.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/ocl_translation_output_impl.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/impl/platform_impl.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/fcl_ocl_translation_ctx.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/fcl_ocl_device_ctx.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/ocl_translation_output.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/../AdaptorOCL/ocl_igc_interface/platform.h"
  )

set(IGC_BUILD__SRC__FCL ${IGC_BUILD__SRC__FCL} PARENT_SCOPE)
set(IGC_BUILD__HDR__FCL ${IGC_BUILD__HDR__FCL} PARENT_SCOPE)

if(LLVM_ON_UNIX)
add_subdirectory(embedder)
set(IGC_BUILD__PROJ__CTHLib_FCL "${IGC_BUILD__PROJ__CTHLib_FCL}" PARENT_SCOPE)
endif()

set(IGC_BUILD__RES__FCL
  "${CMAKE_CURRENT_SOURCE_DIR}/igd_fcl_mcl/resources/ClangResource.rc"
  )
set(IGC_BUILD__RES__FCL ${IGC_BUILD__RES__FCL} PARENT_SCOPE)

source_group(External
  FILES
    ${COMMON_OCL_FILES}/TranslationBlock.h
  )

source_group(Headers  FILES
  ${IGC_BUILD__HDR__FCL}
  )

source_group(Resource FILES
  ${IGC_BUILD__RES__FCL}
  )

source_group(Source FILES
    ${IGC_BUILD__SRC__FCL}
  )

###########################################

include_directories(
"${CMAKE_CURRENT_SOURCE_DIR}"
"../../../Source/OpenCL/Common"
"../../../Source/inc"
"../../../Source/inc/common "
"../../../Source/install/"
"../../../Source/OpenCL/Runtime/${HEADER_DIR}/headers/"
)

=== IGC/VectorCompiler/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2020-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================



# CMake Settings:
# - VC_INTRINSICS_SRC
set(IGC_BUILD__PROJ__VectorCompiler "${IGC_BUILD__PROJ_NAME_PREFIX}VectorCompiler")
set(IGC_BUILD__PROJ__VectorCompiler "${IGC_BUILD__PROJ__VectorCompiler}" PARENT_SCOPE)
# Ordering matters here.
# FIXME: set proper dependencies for VCCodeGen and others.
set(IGC_BUILD__PROJ_VC_LIBS_TO_LINK VCIGCDeps PARENT_SCOPE)

set(IGC_BUILD__PROJ_LABEL__VectorCompiler "${IGC_BUILD__PROJ__VectorCompiler}")

message(STATUS "+++ Source/IGC/VectorCompiler +++")
message(STATUS "[VC] Build proj: ${IGC_BUILD__PROJ__VectorCompiler}")

# --- Options ---

if(LLVM_ON_WIN32)
  # disable 32/64 warnings
  add_compile_options(/wd4244)

  #  disable unary minus to unsigned type warning
  add_compile_options(/wd4146)

  # disable implicitly deleted dtor warning
  add_compile_options(/wd4624)

  # Disable double-inline warning coming from StringRef.h:898
  # For some reason it is not filtered by /external:I option
  add_compile_options(/wd4141)
endif()

# --- VC platforms ---
include(cmake/supported_platforms_list.cmake)

# --- VC Intrinsics ---
include(cmake/handle_vc_intrinsics.cmake)

# --- VC Opt ---

add_subdirectory(include)
add_subdirectory(lib)

# Common utilities that depend on other IGC components.
# These have to be separated because of circular dependencies between
# some components in IGC.
add_subdirectory(igcdeps)

if(IGC_BUILD__CMLIT_ENABLE)
  add_subdirectory(test)
endif()

add_subdirectory(utils)

# --- CMCL  ---
add_subdirectory(CMCL)

=== IGC/ZEBinWriter/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2020-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================

# CMakeList.txt : Top-level CMake project file, do global configuration
# and include sub-projects here.
#
cmake_minimum_required (VERSION 3.8)

project ("ZEBinaryUtilities")

find_package(LLVM REQUIRED CONFIG)


message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")

# Set your project compile flags.
# E.g. if using the C++ header files
# you will need to enable C++11 support
# for your compiler.

include_directories(${LLVM_INCLUDE_DIRS})
add_definitions(${LLVM_DEFINITIONS})

set(VS_DEBUG_COMPILER_OPTIONS
    /MTd
)

set (CMAKE_C_FLAGS "-DZEBinStandAloneBuild")
set (CMAKE_CXX_FLAGS "-DZEBinStandAloneBuild")

# Include sub-projects.
add_subdirectory ("zebin")
add_subdirectory ("tools")

=== external/SPIRV-Tools/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2020-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================

cmake_minimum_required(VERSION 2.8.12)

message(STATUS "============================ SPIRV-Tools project ============================")

if(IGC_OPTION__SPIRV_TOOLS_MODE STREQUAL PREBUILDS_MODE_NAME)

 message(STATUS "[SPIRV-Tools] : IGC_OPTION__SPIRV_TOOLS_MODE set to Prebuilds")
 OPTION(IGC_OPTION__USE_PREINSTALLED_SPIRV_HEADERS OFF)

 if(IGC_OPTION__USE_PREINSTALLED_SPIRV_HEADERS)
  message(STATUS "[SPIRV-Tools] : IGC_OPTION__USE_PREINSTALLED_SPIRV_HEADERS set to ON, using preinstalled SPIRV-Headers")
  message(STATUS "[SPIRV-Tools] : Using preinstalled SPIRV-Headers")
  set(SPIRV-Headers_INCLUDE_DIR "/usr/include")
 else()
  message(STATUS "[SPIRV-Tools] : IGC_OPTION__USE_PREINSTALLED_SPIRV_HEADERS set to OFF")
  message(STATUS "[SPIRV-Tools] : Using default path ${CMAKE_CURRENT_SOURCE_DIR}/../../SPIRV-Headers")
  set(SPIRV-Headers_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../SPIRV-Headers/include")
 endif()

 message(STATUS "[SPIRV-Tools] : Searching prebuilt SPIRV-Tools package")
 find_package(SPIRV-Tools REQUIRED COMPONENTS SPIRV-Tools)
 message(STATUS "[SPIRV-Tools] : Found prebuilt SPIRV-Tools package in: ${SPIRV-Tools_CONFIG}")

 set(SPIRV-Tools_ROOT_DIR "${SPIRV-Tools_DIR}/../../..")
 set(IGC_BUILD__SPIRV-Tools_DIR "${SPIRV-Tools_ROOT_DIR}")

 set(INCLUDE_DIRS_LIST "${SPIRV-Tools_ROOT_DIR}/include" "${SPIRV-Headers_INCLUDE_DIR}")
 if(NOT TARGET SPIRV-Tools)
  add_custom_target(SPIRV-Tools)
 endif()
 set_target_properties(SPIRV-Tools PROPERTIES INCLUDE_DIRECTORIES "${INCLUDE_DIRS_LIST}")
 set(IGC_BUILD__PROJ__SPIRV-Tools SPIRV-Tools)

else() #By default use build from sources
 message(STATUS "[SPIRV-Tools] : IGC_OPTION__SPIRV_TOOLS_MODE set to Source")
 message(STATUS "[SPIRV-Tools] : IGC_OPTION__USE_PREINSTALLED_SPRIV_HEADERS set to OFF")
 message(STATUS "[SPIRV-Tools] : Building from source")
 message(STATUS "[SPIRV-Tools] : Current source dir: ${CMAKE_CURRENT_SOURCE_DIR}")

 set(SPIRV-Headers_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../SPIRV-Headers") # used in subdirectory
 set(SPIRV-Tools_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../SPIRV-Tools")

 set(SPIRV-Tools_OUTPUT_DIR "${IGC_OPTION__OUTPUT_DIR}/external/SPIRV-Tools/build")
 set(IGC_BUILD__SPIRV-Headers_DIR "${SPIRV-Headers_SOURCE_DIR}")
 set(IGC_BUILD__SPIRV-Tools_DIR "${SPIRV-Tools_SOURCE_DIR}")

 # policy CMP0077 workaround
 if (NOT DEFINED DEFAULT_SPIRV_SKIP_EXECUTABLES)
  set(DEFAULT_SPIRV_SKIP_EXECUTABLES ON)
 endif()

 # options used in subdirectory
 option(SKIP_SPIRV_TOOLS_INSTALL "Skip SPIRV-Tools installation" ON)
 option(SPIRV_SKIP_TESTS "Skip building SPIRV-Tools tests along with the library" ON)
 option(SPIRV_SKIP_EXECUTABLES "Skip building SPIRV-Tools executables and tests along with the library" ${DEFAULT_SPIRV_SKIP_EXECUTABLES})
 option(SPIRV_HEADERS_SKIP_INSTALL "Skip SPIRV-Headers installation" ON)
 option(SPIRV_HEADERS_SKIP_EXAMPLES "Skip building SPIRV-Headers examples" ON)

 message(STATUS "SPIRV-Tools source directory: ${SPIRV-Tools_SOURCE_DIR}")
 message(STATUS "SPIRV-Headers source directory: ${SPIRV-Headers_SOURCE_DIR}")
 message(STATUS "SPIRV-Tools output directory: ${SPIRV-Tools_OUTPUT_DIR}")
 message(STATUS "Option SKIP_SPIRV_TOOLS_INSTALL: ${SKIP_SPIRV_TOOLS_INSTALL}")
 message(STATUS "Option SPIRV_SKIP_TESTS: ${SPIRV_SKIP_TESTS}")
 message(STATUS "Option SPIRV_SKIP_EXECUTABLES: ${SPIRV_SKIP_EXECUTABLES}")
 message(STATUS "Option SPIRV_HEADERS_SKIP_INSTALL: ${SPIRV_HEADERS_SKIP_INSTALL}")
 message(STATUS "Option SPIRV_HEADERS_SKIP_EXAMPLES: ${SPIRV_HEADERS_SKIP_EXAMPLES}")

 find_package(Python3 REQUIRED)
 add_subdirectory("${SPIRV-Tools_SOURCE_DIR}" "${SPIRV-Tools_OUTPUT_DIR}" EXCLUDE_FROM_ALL)
 set(IGC_BUILD__PROJ__SPIRV-Tools "SPIRV-Tools") # same name as in subdirectory
 set(IGC_BUILD__PROJ__SPIRV-Tools-opt "SPIRV-Tools-opt")

endif() #SPIRV_TOOLS_MODE

message(STATUS "=============================================================================")

=== visa/iga/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2017-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================

# IGC depends on this; so it's safe to use here
cmake_minimum_required(VERSION 3.13)
message(" cmake version: ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}")

if(NOT IGC_BUILD)
  enable_testing()
endif()

project(IGA)

include (BuildSetup.cmake)
include (BuildFunctions.cmake)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

# do static build for IGA standalone build
set(LINK_AS_STATIC_LIB TRUE)

include_directories(include)
include_directories("../../inc")

set(GED_BRANCH GED_external)
add_subdirectory(GEDLibrary/${GED_BRANCH})
add_subdirectory(IGALibrary)
add_subdirectory(IGAExe)

=== IGC/AdaptorOCL/CLElfLib/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2017-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================

# We require cmake 3.2.0 or later
cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)

# We want to organize our IDE targets into folders
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# This is the main CLElfLib project's cmakelists.txt file
project(CLElfLib)

# Set up a comprehensive source list
set(CLELFLIB_READER_SRCS
    ${CLELFLIB_READER_SRCS}
    "${CMAKE_CURRENT_SOURCE_DIR}/ElfReader.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ElfReader.h"
)

set(CLELFLIB_WRITER_SRCS
    ${CLELFLIB_WRITER_SRCS}
    "${CMAKE_CURRENT_SOURCE_DIR}/ElfWriter.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ElfWriter.h"
)

set(CLELFLIB_SRCS
    ${CLELFLIB_SRCS}
    "${CMAKE_CURRENT_SOURCE_DIR}/CLElfTypes.h"
    ${CLELFLIB_READER_SRCS}
    ${CLELFLIB_WRITER_SRCS}
)

# We want to create a lib so that everything in it can be tested
add_library(CLElfLib STATIC ${CLELFLIB_SRCS})

set_target_properties(CLElfLib PROPERTIES POSITION_INDEPENDENT_CODE ON)

# The following filters are added to the VS IDE representation
source_group("source files" FILES "${CMAKE_CURRENT_SOURCE_DIR}/CLElfTypes.h")
source_group("source files\\Reader" FILES ${CLELFLIB_READER_SRCS})
source_group("source files\\Writer" FILES ${CLELFLIB_WRITER_SRCS})

# group the igdrcl specific projects
set_target_properties(CLElfLib PROPERTIES FOLDER "elf utilities")


target_link_libraries(CLElfLib ${ASAN_LIB} ${TSAN_LIB})
set_property(TARGET CLElfLib APPEND_STRING PROPERTY COMPILE_FLAGS ${ASAN_FLAGS} ${TSAN_FLAGS})

=== IGC/Compiler/CISACodeGen/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2017-2022 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================


include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

set(IGC_BUILD__SRC__CISACodeGen_Common
    "${CMAKE_CURRENT_SOURCE_DIR}/AddressArithmeticSinking.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/AdvCodeMotion.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/AdvMemOpt.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/AtomicOptPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RematAddressArithmetic.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/AnnotateUniformAllocas.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/BlockCoalescing.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/BlockMemOpAddrScalarizationPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CapLoopIterationsPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CastToGASAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CallMergerPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CISABuilder.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CShader.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CShaderProgram.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CVariable.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CheckInstrTypes.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CoalescingEngine.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CodeScheduling.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CodeSinking.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ComputeShaderBase.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ConstantCoalescing.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CSWalkOrder.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/DeSSA.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/DebugInfo.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/DpasScan.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/EmitVISAPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/Emu64OpsPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/EvaluateFreeze.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/EstimateFunctionSize.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenerateFrequencyData.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/FixAddrSpaceCast.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/FixupExtractValuePair.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/FoldKnownWorkGroupSizes.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenCodeGenModule.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenerateBlockMemOpsPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenericShaderState.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenIRLowering.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenSimplification.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/getCacheOpts.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/HalfPromotion.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/HoistCongruentPhi.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LdShrink.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LiveVars.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LivenessAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LoopDCE.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LowerGEPForPrivMem.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LSCCacheOptimizationPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LSCControlsAnalysisPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/MatchCommonKernelPatterns.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/MemOpt.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/MemOpt2.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/MemOptUtils.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/OpenCLOptions.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/OpenCLKernelCodeGen.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/POSH_RemoveNonPositionOutput.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PartialEmuI64OpsPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PassTimer.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PatternMatchPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PayloadMapping.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PositionDepAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PreRARematFlag.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PrepareLoadsStoresPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PrepareLoadsStoresUtils.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PromoteConstantStructs.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PromoteInt8Type.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/SinkCommonOffsetFromGEP.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/SplitLoads.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PruneUnusedArguments.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PullConstantHeuristics.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PushAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RayTracingShaderLowering.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RayTracingStatefulPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RegisterEstimator.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RegisterPressureEstimate.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RemoveLoopDependency.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ResolvePredefinedConstant.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ResourceLoopAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/FPRoundingModeCoalescing.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RuntimeValueLegalizationPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/SLMConstProp.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ScalarizerCodeGen.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ShaderCodeGen.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/Simd32Profitability.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/SimplifyConstant.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/TimeStatsCounter.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/TranslationTable.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/TypeDemote.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/UniformAssumptions.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/VariableReuseAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/VectorPreProcess.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/VectorProcess.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/VectorShuffleAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/WIAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/helper.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/layout.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/messageEncoding.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IGCLivenessAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IGCFunctionExternalPressure.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LoopCountAnalysis.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IGCVectorizer.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ResourceLoopUnroll.cpp"
  )



set(IGC_BUILD__SRC__Compiler_CISACodeGen
    ${IGC_BUILD__SRC__CISACodeGen_Common}
    PARENT_SCOPE
    )

set(IGC_BUILD__HDR__CISACodeGen_Common
    "${CMAKE_CURRENT_SOURCE_DIR}/AddressArithmeticSinking.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/AdvCodeMotion.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/AtomicOptPass.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RematAddressArithmetic.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/AdvMemOpt.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/AnnotateUniformAllocas.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/BlockCoalescing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/BlockMemOpAddrScalarizationPass.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CapLoopIterationsPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/CastToGASAnalysis.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/CallMergerPass.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CISABuilder.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CISACodeGen.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/CVariable.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CShaderProgram.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CheckInstrTypes.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CoalescingEngine.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CodeScheduling.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CodeSinking.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ComputeShaderBase.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ConstantCoalescing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CSWalkOrder.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/DeSSA.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/DebugInfo.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/DebugInfoData.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/DpasScan.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/DriverInfo.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/EmitVISAPass.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/Emu64OpsPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/EvaluateFreeze.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/EstimateFunctionSize.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenerateFrequencyData.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/FixAddrSpaceCast.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/FixupExtractValuePair.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/FoldKnownWorkGroupSizes.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenCodeGenModule.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenerateBlockMemOpsPass.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenericShaderState.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenIRLowering.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/GenSimplification.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/getCacheOpts.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/HalfPromotion.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/HoistCongruentPhi.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LdShrink.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/LiveVars.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LivenessAnalysis.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LowerGEPForPrivMem.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/LSCCacheOptimizationPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/LSCControlsAnalysisPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/MatchCommonKernelPatterns.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/MemOpt.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/MemOpt2.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/MemOptUtils.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/OpenCLOptions.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/OpenCLKernelCodeGen.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/POSH_RemoveNonPositionOutput.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/PartialEmuI64OpsPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/PassTimer.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PatternMatchPass.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PayloadMapping.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/Platform.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PositionDepAnalysis.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PreRARematFlag.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/PrepareLoadsStoresPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/PrepareLoadsStoresUtils.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/PromoteConstantStructs.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PromoteInt8Type.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PullConstantHeuristics.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PushAnalysis.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RayTracingShaderLowering.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RayTracingStatefulPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/RegisterEstimator.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RegisterPressureEstimate.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RemoveLoopDependency.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ResolvePredefinedConstant.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/ResourceLoopAnalysis.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/FPRoundingModeCoalescing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RuntimeValueLegalizationPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/SLMConstProp.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ScalarizerCodeGen.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ShaderCodeGen.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ShaderUnits.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/SplitLoads.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/Simd32Profitability.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/SinkCommonOffsetFromGEP.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/TimeStatsCounter.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/TranslationTable.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/TypeDemote.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/UniformAssumptions.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/VariableReuseAnalysis.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/VectorProcess.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/VectorShuffleAnalysis.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/WIAnalysis.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/helper.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/layout.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/messageEncoding.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/opCode.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/IGCLivenessAnalysis.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/LoopCountAnalysis.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IGCVectorizer.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/ResourceLoopUnroll.hpp"
  )



set(IGC_BUILD__HDR__Compiler_CISACodeGen
    ${IGC_BUILD__HDR__CISACodeGen_Common}
    PARENT_SCOPE
    )

igc_sg_register(
    Compiler__CISACodeGen
    "CISACodeGen"
    FILES
      ${IGC_BUILD__SRC__CISACodeGen}
      ${IGC_BUILD__HDR__CISACodeGen}
  )

=== IGC/Compiler/Optimizer/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2017-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================

#
#
include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

add_subdirectory(OpenCLPasses)


add_subdirectory(IGCInstCombiner)

set(IGC_BUILD__SRC__Optimizer
    "${CMAKE_CURRENT_SOURCE_DIR}/BuiltInFuncImport.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/CodeAssumption.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GatingSimilarSamples.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IndirectCallOptimization.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IntDivConstantReduction.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IntDivRemCombine.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/MarkReadOnlyLoad.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/MCSOptimization.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/OCLBIConverter.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/OCLBIUtils.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PreCompiledFuncImport.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PromoteToPredicatedMemoryAccess.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/HoistConvOpToDom.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ReduceOptPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/Scalarizer.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/SynchronizationObjectCoalescing.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ValueTracker.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/RuntimeValueVectorExtractPass.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/BarrierControlFlowOptimization.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/WaveShuffleIndexSinking.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/WaveAllJointReduction.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IntDivRemIncrementReduction.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/InstructionHoistingOptimization.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/WaveBallotCSE.cpp"
  )

set(IGC_BUILD__SRC__Compiler_Optimizer
    ${IGC_BUILD__SRC__Optimizer}
    ${IGC_BUILD__SRC__Optimizer_OpenCLPasses}
    ${IGC_BUILD__SRC__Optimizer_IGCInstCombiner}
    PARENT_SCOPE
  )

set(IGC_BUILD__HDR__Optimizer
    "${CMAKE_CURRENT_SOURCE_DIR}/BuiltInFuncImport.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/CodeAssumption.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/GatingSimilarSamples.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IndirectCallOptimization.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IntDivConstantReduction.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IntDivRemCombine.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/MCSOptimization.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/OCLBIConverter.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/OCLBIUtils.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/PreCompiledFuncImport.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/PromoteToPredicatedMemoryAccess.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/HoistConvOpToDom.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ReduceOptPass.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/Scalarizer.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/SynchronizationObjectCoalescing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ValueTracker.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/RuntimeValueVectorExtractPass.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/BarrierControlFlowOptimization.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/WaveShuffleIndexSinking.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/WaveAllJointReduction.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/IntDivRemIncrementReduction.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/InstructionHoistingOptimization.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/WaveBallotCSE.hpp"
  )

set(IGC_BUILD__HDR__Optimizer
    ${IGC_BUILD__HDR__Optimizer}
    "${CMAKE_CURRENT_SOURCE_DIR}/../Builtins/LibraryDPEmu.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/../Builtins/LibraryMiscEmu.hpp"
  )

set(IGC_BUILD__HDR__Compiler_Optimizer
    ${IGC_BUILD__HDR__Optimizer}
    ${IGC_BUILD__HDR__Optimizer_OpenCLPasses}
    ${IGC_BUILD__HDR__Optimizer_IGCInstCombiner}
    PARENT_SCOPE
  )


igc_sg_register(
    Compiler__Optimizer
    "Optimizer"
    GROUPS
      Compiler__Optimizer_OpenCLPasses
      Compiler__Optimizer_IGCInstCombiner
    FILES
      ${IGC_BUILD__SRC__Optimizer}
      ${IGC_BUILD__HDR__Optimizer}
  )

=== IGC/Compiler/tests/CMakeLists.txt ===
#=========================== begin_copyright_notice ============================
#
# Copyright (C) 2018-2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
#
#============================ end_copyright_notice =============================

#
#

if(NOT TARGET igc_opt)
  message("[check-igc] LIT tests disabled. Missing igc_opt target.")
  return()
endif()
if(DEFINED ENV{DISABLE_check-igc})
  message("[check-igc] LIT tests disabled. DISABLE_check-igc is defined as an env variable.")
  return()
endif()
if(NOT IGC_OPTION__ENABLE_LIT_TESTS)
  return()
endif()

# Variables set here are used by `configure_file` call and by
# `add_lit_testsuite` later on.
set(IGC_TEST_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(IGC_TEST_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>)
set(IGC_LIT_CONFIG_FILE ${IGC_TEST_BINARY_DIR}/lit.site.cfg.py)

igc_configure_lit_site_cfg(
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
  ${IGC_LIT_CONFIG_FILE}
  MAIN_CONFIG
    ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py
  )

# If any new tool is required by any of the LIT tests add it here:
set(IGC_LIT_TEST_DEPENDS
  FileCheck
  split-file
  count
  not
  "${IGC_BUILD__PROJ__igc_opt}"
  )


# Note:
# This command must be consistent with lit.cfg.py in the following points:
# 1) the path to tests must be consistent with config.test_source_root
# 2) the suffix must be consistent with config.suffixes
# The consistency can be achived by calling a process which returns the list of tests.
file(GLOB_RECURSE _tests "${IGC_TEST_SOURCE_DIR}/*.ll")
file(GLOB_RECURSE _site_config_files "${CMAKE_CURRENT_BINARY_DIR}/*/lit.site.cfg.py")

# This will create a target called `check-igc`, which will run all tests from
# IGC/Compiler/tests directory. The tests will be run on files in the source
# directory, since they are not modified, there doesn't seem to be any reason
# for copying them.
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.17")
  igc_add_lit_target(check-igc "${IGC_TEST_BINARY_DIR}" "Running the IGC LIT tests"
    DEPENDS ${IGC_LIT_TEST_DEPENDS} ${_tests} ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in ${IGC_LIT_CONFIG_FILE}
    SOURCES ${_tests} ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in ${_site_config_files}
    )
else()
  add_lit_testsuite(check-igc "Running the IGC LIT tests"
    ${IGC_TEST_BINARY_DIR}
    DEPENDS ${IGC_LIT_TEST_DEPENDS}
    )
endif()

if(MSVC)
  source_group(TREE "${IGC_TEST_SOURCE_DIR}" PREFIX "tests" FILES ${_tests})
  source_group(TREE "${CMAKE_CURRENT_SOURCE_DIR}" PREFIX "config" FILES ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py)
  source_group(TREE "${CMAKE_CURRENT_BINARY_DIR}" PREFIX "config/generated" FILES ${_site_config_files})
endif()

# Tests should not be excluded from "Build Solution" in VS.
set_target_properties(check-igc
  PROPERTIES
    EXCLUDE_FROM_DEFAULT_BUILD OFF
    EXCLUDE_FROM_ALL OFF
  )

# Line below is just used to group LIT-related targets in single directory
# in IDE. This is completely optional.
set_target_properties(check-igc PROPERTIES FOLDER "Tests/LIT Tests")

=== debian/changelog ===
intel-graphics-compiler2 (2.16.0-2ubuntu1) questing; urgency=medium

  * Build with gcc-14.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 29 Aug 2025 09:21:39 +0300

intel-graphics-compiler2 (2.16.0-2) unstable; urgency=medium

  * rules: Fix broken buildflags.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 25 Aug 2025 21:50:34 +0300

intel-graphics-compiler2 (2.16.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-dep on vc-intrinsics.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 25 Aug 2025 19:02:46 +0300

=== debian/control ===
Source: intel-graphics-compiler2
Section: libs
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
 bison,
 cmake,
 flex,
 python3,
 python3-mako,
 spirv-headers,
 spirv-tools,
 zlib1g-dev,
# keep the clang/llvm version in sync
 clang-14,
 intel-vc-intrinsics-14-dev (>= 0.23.1),
 liblld-14-dev,
 libllvmspirvlib-14-dev,
 libopencl-clang-14-dev,
 llvm-14-dev,
 g++-14,
 gcc-14,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://github.com/intel/intel-graphics-compiler
Vcs-Browser: https://salsa.debian.org/opencl-team/intel-graphics-compiler
Vcs-Git: https://salsa.debian.org/opencl-team/intel-graphics-compiler.git

Package: libigc2
Architecture: any-amd64
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Provides:
 libigc2+llvm${llvm:Version},
Description: Intel graphics compiler for OpenCL -- core libs
 The Intel(R) Graphics Compiler for OpenCL(TM) is an llvm based compiler
 for OpenCL(TM) targeting Intel Gen graphics hardware architecture.
 .
 This package includes the core libraries.

Package: libigc2-tools
Architecture: any-amd64
Section: video
Breaks: libigc-tools
Conflicts: libigc-tools
Replaces: libigc-tools
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Intel graphics compiler for OpenCL -- media tools
 The Intel(R) Graphics Compiler for OpenCL(TM) is an llvm based compiler
 for OpenCL(TM) targeting Intel Gen graphics hardware architecture.
 .
 This package includes tools for the media driver.

Package: libigdfcl2
Architecture: any-amd64
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Provides:
 libigdfcl2+llvm${llvm:Version},
Description: Intel graphics compiler for OpenCL -- OpenCL library
 The Intel(R) Graphics Compiler for OpenCL(TM) is an llvm based compiler
 for OpenCL(TM) targeting Intel Gen graphics hardware architecture.
 .
 This package includes the library for OpenCL.

Package: libigdfcl2-dev
Architecture: any-amd64
Multi-Arch: same
Section: libdevel
Depends:
 libigdfcl2 (= ${binary:Version}),
 ${misc:Depends},
Conflicts: libigdfcl-dev
Description: Intel graphics compiler for OpenCL -- OpenCL development files
 The Intel(R) Graphics Compiler for OpenCL(TM) is an llvm based compiler
 for OpenCL(TM) targeting Intel Gen graphics hardware architecture.
 .
 This package includes files for IGC OpenCL development.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all optimize=-lto
export CC=gcc-14
export CXX=g++-14

include /usr/share/dpkg/pkg-info.mk

LLVM_VERSION		 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)
LLVM_UPSTREAM_VERSION	 = $(shell dpkg-query -f '$${source:Upstream-Version}' -W llvm-$(LLVM_VERSION)-dev)

%:
	dh $@ --builddir build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DIGC_OPTION__ARCHITECTURE_TARGET='Linux64' \
		-DIGC_OPTION__LLVM_PREFERRED_VERSION=$(LLVM_UPSTREAM_VERSION) \
		-DIGC_OPTION__CLANG_MODE=Prebuilds \
		-DIGC_OPTION__LLD_MODE=Prebuilds \
		-DIGC_OPTION__LLVM_MODE=Prebuilds \
		-DIGC_OPTION__SPIRV_TOOLS_MODE=Prebuilds \
		-DIGC_OPTION__SPIRV_TRANSLATOR_MODE=Prebuilds \
		-DIGC_OPTION__VC_INTRINSICS_MODE=Prebuilds \
		-DIGC_OPTION__LINK_KHRONOS_SPIRV_TRANSLATOR=ON \
		-DIGC_OPTION__USE_PREINSTALLED_SPIRV_HEADERS=ON \
		-DLLVM_ROOT=/usr/lib/llvm-$(LLVM_VERSION)/  \
		-Wno-dev

execute_after_dh_auto_install:
	$(RM) -v debian/tmp/usr/include/igc/cif/CMakeLists.txt
	$(RM) -v debian/tmp/usr/include/igc/cif/cif/CMakeLists.txt
	$(RM) -v debian/tmp/usr/include/igc/cif/readme.txt

	$(RM) -v debian/tmp/usr/lib/*/libiga64.so
	$(RM) -v debian/tmp/usr/lib/*/libigc.so

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'llvm:Version=$(LLVM_VERSION)'

override_dh_dwz:

gentarball:
	tar --transform 's,^,$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)/,' \
		--exclude 'debian' --exclude-vcs \
		-cJf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig.tar.xz .
